- Set up payment intent to pay with Crypto
- Acquire blockchain address customer will pay to
- Customer pays
- Receive payment

1. Pay with Crypto
Once the customer reaches checkout and confirms they would like to pay with USDC on Ethereum, your system will send Circle a request to create a payment intent. Within this payment intent request you will specify the amount, currency, settlement currency, and chain. Create a payment intent:Response
Webhook notification
2. Acquire blockchain address customer will pay to
For security reasons, we do not synchronously return the deposit blockchain address. To retrieve the blockchain deposit address, you have two options:- Subscribe to webhook notifications
- Poll Circle APIs
Option 1: Webhook Notification
To receive webhook notifications, follow the steps in the notifications quickstart. After you subscribe to notifications, you will receive updates for the payment intent whenever the resource is updated. In this case, when thepaymentMethods.address is set, a notification is sent with a new timeline
object with a status of pending.
Payment intent webhook notification
Option 2: Poll Payment Intent Endpoint
If you prefer to poll get a payment intent, you can sendget request until you receivepaymentMethods.address.
Retrieve payment intent:
Response
3. Enable customer payment
Once you receive the deposit address viapaymentMethods.address, you’ll
provide it to the customer along with the amount and currency to be paid. You
can present the address two ways:
- as plain text the customer can cut and paste; or
- as a QR code the customer can scan via an app.
When using transient payment intents, you can specify the timeframe in which
the customer must send payment by adjusting the
expiresOn setting.4. Receive payment from Circle
Once Circle obtains payment on-chain, we create a Payment resource linked to the Payment Intent created earlier and update the status of that Payment Intent. Your firm will then receive payment via the method specified.Option 1: Webhook Notifications
Payment intent webhook notification
Payment webhook notification
Option 2: Retrieve Payment Intent and Payment
Retrieve a payment intent:Response
Response
For blockchains that require a ‘memo’ or ‘address tag’ (XLM, HBAR, etc.), the
optional
addressTag field will be present in the depositAddress object.1. Get a Typed Message for Signing
Call theGET /payment/presign endpoint to fetch the typed message. The two
required parameters are paymentIntentId , which can be retrieved from the
GET /paymentIntent response or webhook notification; and endUserAddress
which is the consumer wallet address.
Curl
Response
2. Customers Sign the Transaction From Their Wallet
You will need to trigger the customer’s wallet using the response from/presign.
For example, if you use the
signTypedData function from wagmi,
you will need to fill out the domain, types and values fields.

3. Create a Crypto Payment with Customers’ Signature
With a customer’s raw signature, Circle can create a crypto payment with thePOST /payment/crypto endpoint.
Curl
Response